Bug 696052

Summary: Review Request: texlive-tetex-cmsuper - The CM-Super font set
Product: [Fedora] Fedora Reporter: Lev Shamardin <shamardin>
Component: Package ReviewAssignee: Mohamed El Morabity <pikachu.2014>
Status: CLOSED NOTABUG QA Contact: Fedora Extras Quality Assurance <extras-qa>
Severity: medium Docs Contact:
Priority: medium    
Version: rawhideCC: fedora-package-review, pikachu.2014
Target Milestone: ---   
Target Release: ---   
Hardware: All   
OS: Linux   
Whiteboard:
Fixed In Version: Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2014-02-12 04:35:20 EST Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
Bug Depends On:    
Bug Blocks: 201449    

Description Lev Shamardin 2011-04-13 03:07:33 EDT
Spec URL: http://fedorapeople.org/~abbot/texlive-tetex-cmsuper.spec
SRPM URL: http://fedorapeople.org/~abbot/texlive-tetex-cmsuper-0.3.3-11.fc14.src.rpm
Description:
The CM-Super package contains Type 1 fonts converted from METAFONT
fonts and covers entire EC/TC, ECC and LH fonts (Computer Modern font
families). All European and Cyrillic writings are covered. Each Type 1
font program contains ALL glyphs from the following standard LaTeX
font encodings: T1, TS1, T2A, T2B, T2C, X2, and also Adobe
StandardEncoding (585 glyphs per non-SC font and 468 glyphs per SC
font), and could be reencoded to any of these encodings using standard
dvips or pdftex facilities (the corresponding support files are also
included).
Comment 1 Mohamed El Morabity 2011-04-13 06:42:58 EDT
I will review this package.
Comment 2 Mohamed El Morabity 2011-04-13 19:04:35 EDT
Here are some comments:

* A tacite rule for naming (La)TeX packages not part of the Fedora TeX Live packages (or RHEL teTeX) is that the package name should start by « tex- »; your package should be named tex-cmsuper, with no reference to the (La)TeX distribution.

* The Type 1 fonts are licensed under the GPL with font exception. This should be mentionned in the License tag.

* In the Requires:
   Requires(post): texlive >= 2007
   Requires(preun): texlive >= 2007
   Requires(postun): texlive >= 2007
Is the condition « texlive >= 2007 » really necessary? Fedora and RHEL 6 never included versions of TeX Live prior to 2007.
By the way:
   Requires:	texlive-dvips
   Requires:	dvipdfm
Are these packages really required to use these fonts in (La)TeX?

* In the %install section, you create two scripts, tetex-addfonts-cmsuper and tetex-removefonts-cmsuper. Why? It doesn't make sense to provides them to the users of the package.

* Please consider http://fedoraproject.org/wiki/Packaging_tricks#Installing_TeX_files_.28unvetted.29 for the %post/%postun actions relative to (La)TeX packages. For the updmap tweaks in these sections, you can refer to the tex-fonts-hebrew or the tex-cm-lgc packages (since there is no specific guidelines for updmap in %post/%postun).

* Because of the fonts themselves, the package is quite huge. Why not splitting it into subpackages:
- one for the TeX files;
- some for the Type1 fonts?
You can refer again to tex-cm-lgc for example for it, which uses this approach.
Comment 3 Mohamed El Morabity 2011-04-26 20:59:53 EDT
Ping?
Comment 4 Lev Shamardin 2011-05-03 15:20:59 EDT
Sorry for a big delay.
I've considered rewriting the whole package in the spirit of ctan-cm-lgc-fonts. There is a big number of changes, quick summary:

* Fixed License and Version (my bad, actual version of the fonts was 0.3.4, not 0.3.3).
* Package divided into 6 subpackages now: ctan-cm-super-fonts-common, ctan-cm-super-misc-fonts, ctan-cm-super-roman-fonts, ctan-cm-super-sans-fonts, ctan-cm-super-typewriter-fonts, tex-cm-super.
* Rewrite of %post sections

Updated spec and SRPM:

http://fedorapeople.org/~abbot/ctan-cm-super-fonts.spec
http://fedorapeople.org/~abbot/ctan-cm-super-fonts-0.3.4-1.fc14.src.rpm

There are still some questions/points to consider:
1. Are the fontconfig files for these fonts needed, really? At current moment I didn't write them, because of:
2. I'm not sure if these fonts are required in /usr/share/fonts at all, since the use for them outside of TeX seems to be very limited.

Also please note, that installation of ctan-cm-super-*-fonts-* packages may cause BIG X11 hangups (up to dozens of seconds). Don't know if this can be fixed, seems to be Gnome/X11 issue, not the font packages.
Comment 5 Lev Shamardin 2011-05-27 00:54:22 EDT
Ping?
Comment 6 Mohamed El Morabity 2011-05-29 11:02:18 EDT
Sorry for this late answer, the promotion of the Fedora 15 release took me much time ^^

The job you've done with this new version is really impressive! We are near to approve this package :)

Just some comments anyway:

* in %post, you can summarize all the updmap-sys calls with a for loop:

   %post -n %{texfontpkg}
   texhash
   conffile="$(texconfig-sys conf | grep updmap.cfg)"
   if [ "$1" -eq "1" ]; then
       for map_file in cm-super-{t1,t2a,t2b,t2c,ts1,x2}; do
          updmap-sys --quiet --nohash --cnffile ${conffile} --enable Map $map_file
       done
   fi

   You can do the same in %postun

* Don't forget to install the type1ec.sty package file provided in the archive (in %{buildroot}%{texfonts}/tex/latex/%{fontpkg}/).

* In the tex-cm-super subpackage, you can remove the following Provides:
   Provides: tetex-font-cm-super = %{version}-%{release}
   It was a legacy from the time when TeX packages not part of teTeX where name tetex-something instead of tex-something nowadays.

> 2. I'm not sure if these fonts are required in /usr/share/fonts at all, since
> the use for them outside of TeX seems to be very limited.
These fonts can be used outside the TeX world, as for the LGC ones. So they should be available to anyone wanting to use such fonts without using LaTeX.

> Also please note, that installation of ctan-cm-super-*-fonts-* packages may
> cause BIG X11 hangups (up to dozens of seconds). Don't know if this can be
> fixed, seems to be Gnome/X11 issue, not the font packages.
It comes probably from the post-actions automatically added to the font packages (call of fc-cache). Since these packages contain a huge number of fonts to be analysed, this may be understable.
Comment 7 Lev Shamardin 2011-06-04 14:53:41 EDT
(In reply to comment #6)
> * in %post, you can summarize all the updmap-sys calls with a for loop:
Done.

> * Don't forget to install the type1ec.sty package file provided in the archive
> (in %{buildroot}%{texfonts}/tex/latex/%{fontpkg}/).

I guess you meant %{buildroot}%{_texmf_main}/tex/latex/%{fontpkg}, done.

> * In the tex-cm-super subpackage, you can remove the following Provides:
>    Provides: tetex-font-cm-super = %{version}-%{release}

Done.

Updated SPEC and SRPM:
SPEC: http://fedorapeople.org/~abbot/ctan-cm-super-fonts.spec
SRPM: http://fedorapeople.org/~abbot/ctan-cm-super-fonts-0.3.4-2.fc14.src.rpm
Comment 8 Mohamed El Morabity 2011-06-11 05:44:37 EDT
That's almost perfect :). Just add the fontconfig files and it will be OK. You can take those from ctan-lgc-fonts and adapt theme a little bit.
Comment 9 Mohamed El Morabity 2011-07-14 05:47:23 EDT
Ping?
Comment 10 Mohamed El Morabity 2011-09-08 18:42:34 EDT
Ping again?
The review is stalled for a month.
Comment 11 Mohamed El Morabity 2011-10-26 09:28:47 EDT
Without any action on this review within a month, it will be unfortunately closed.
   http://fedoraproject.org/wiki/Package_maintainer_policy#Reviewer_not_responding
Comment 12 Lev Shamardin 2011-11-06 15:14:13 EST
Hi,

Sorry for a long loitering with this. Hopefully here is the last set of modifications. Changed:

- Added fontconfig files.
- Moved sfbs*, sfbbx* fonts from roman to sans subpackage.
- Moved isfltt* fonts from sans to typewriter subpackage.

I'm not sure if I got right how to write fontconfig files for these, because almost all of the fonts in these packages have absolutely the same family ("Computer Modern"), but lots of different styles.

SPEC: http://fedorapeople.org/~abbot/ctan-cm-super-fonts.spec
SRPM: http://fedorapeople.org/~abbot/ctan-cm-super-fonts-0.3.4-3.fc14.src.rpm
Comment 13 Mohamed El Morabity 2011-12-07 04:26:45 EST
Sorry for this late answer... And sorry too for making you write useless fontconfig files: according to the font guidelines:
   http://fedoraproject.org/wiki/Choosing_the_right_font_format_to_package
   "Do not package new Type1 fonts. If someone cares about a Type1 font, he should get it converted to OpenType CFF before we consider packaging it."
In other words, we should not install Type 1 fonts in /usr/share/fonts/ and make them available outside the texmf tree. I really don't think converting fonts to make them available to any application is worthy here, unless you get in touch with their maintained to plan it. But it would take some time to fit the fonts with OpenType features.
I'd suggest you to keep the package splitting, but to install the fonts in their usual place, in /usr/share/texmf/fonts/, as well as remove all the fontconfig stuff.